=== modified file 'src/com/goldencode/p2j/uast/ClassDefinition.java'
--- old/src/com/goldencode/p2j/uast/ClassDefinition.java	2022-05-16 16:24:45 +0000
+++ new/src/com/goldencode/p2j/uast/ClassDefinition.java	2022-05-23 20:10:15 +0000
@@ -3730,16 +4176,16 @@
     *
     * @return   List of possible methods that match.  This may be an empty list if no match exists.
     */
-   private List<MemberData> candidates(String            name,
-                                       int               num,
-                                       int               access,
-                                       boolean           isStatic,
-                                       boolean           internal,
-                                       boolean           first,
-                                       Set<SignatureKey> exist)
+   private List<MatchMetrics> candidates(String            name,
+                                          int               num,
+                                          int               access,
+                                          boolean           isStatic,
+                                          boolean           internal,
+                                          boolean           first,
+                                          Set<SignatureKey> exist)
    {
-      Set<SignatureKey> existing = exist == null ? new HashSet<>() : exist;
-      List<MemberData>  results  = new ArrayList<>();
+      Set<SignatureKey>   existing = exist == null ? new HashSet<>() : exist;
+      List<MatchMetrics> results  = new LinkedList<>();
       
       synchronized (lock)
       {
@@ -3753,25 +4199,32 @@
             {
                if (first)
                {
-                  results.add(defs.values().iterator().next());
+                  results.add(new MatchMetrics(defs.values().iterator().next()));
                   
                   return results;
                }
                
                Iterator<MemberData> iter = defs.values().iterator();
                
-               outer:
                while (iter.hasNext())
                {
                   MemberData dat = checkAccessRights(iter.next(), access);
                   
                   if (dat != null && dat.signature.length == num)
                   {
-                     SignatureKey key = (num > 0) ? new SignatureKey(dat.signature) : null;
-                     
-                     if (num == 0 || !existing.contains(key))
-                     {
-                        results.add(dat);
+                     // special case: no parameters; this is Highlander (i.e. "there can be only one")
+                     // and we don't have to search the parents, this is the match
+                     if (num == 0)
+                     {
+                        results.add(new MatchMetrics(dat));
+                        return results;
+                     }
+                     
+                     SignatureKey key = new SignatureKey(dat.signature);
+                     
+                     if (!existing.contains(key))
+                     {
+                        results.add(new MatchMetrics(dat));
                         existing.add(key);
                      }
                   }
@@ -3788,7 +4241,7 @@
             
             for (ClassDefinition parent : parents)
             {
-               // recurse up inheritence hierarchy
+               // recurse up inheritance hierarchy
                results.addAll(parent.candidates(name, num, _access, isStatic, internal, first, existing));
             }
          }
@@ -3850,6 +4303,101 @@
       
       return type;
    }
+
+   /**
+    * Detect if the given class is an instance of an implemented interface of this class.
+    * 
+    * @param    cls
+    *           The class to check.
+    *           
+    * @return   {@code true} if the given class is an implemented interface in this class. 
+    */
+   private boolean isImplemented(ClassDefinition cls)
+   {
+      if (ifaces == null)
+      {
+         return false;
+      }
+      
+      return ifaces.contains(cls.getName()) || ifaces.contains(cls.getName().toLowerCase());
+   }
+   
+   /**
+    * Detect if the given class is an instance of a parent class or an implemented interface of a parent
+    * class.
+    * 
+    * @param    cls
+    *           The class to check.
+    * @param    ifaces
+    *           {@code true} if implemented interfaces should be checked.
+    * @param    incrementer
+    *           Code to be executed to increment the inheritance level.
+    *
+    * @return   {@code true} if the given class is a parent class or an implemented interface of a parent
+    *           class. 
+    */
+   private boolean isInheritedFrom(ClassDefinition cls, boolean ifaces, Runnable incrementer)
+   {
+      if (parents != null)
+      {
+         for (ClassDefinition parent : parents)
+         {
+            if (cls == parent || (ifaces && parent.isImplemented(cls)))
+            {
+               // track the current parent level
+               incrementer.run();
+
+               return true;
+            }
+            
+            if (parent.isInheritedFrom(cls, ifaces, incrementer))
+            {
+               // track our level's contribution to the parent level
+               incrementer.run();
+               
+               return true;
+            }
+         }
+      }
+      
+      return false;
+   }
+   
+   /**
+    * Parse the given object spec (in the form "object<? extends _CLS_>" or "jobject<? extends _CLS_>") and
+    * return the class definition associated with _CLS_.
+    * 
+    * @param    spec
+    *           The specification to parse.
+    *           
+    * @return   The class definition or {@code null} if the spec was malformed or if there is no such
+    *           definition.
+    */
+   private ClassDefinition parseObjectSpec(String spec)
+   {
+      String sig = "object<? extends ";
+      int    idx = spec.indexOf(sig);
+      
+      ClassDefinition cls = null;
+      
+      if (idx != -1)
+      {
+         String cname = spec.substring(idx + sig.length(), spec.length() - 1);
+         
+         cls = SymbolResolver.getClassDefinition(cname);
+         
+         if (cls == null)
+         {
+            System.err.printf("ERROR: No class found for %s (object spec %s)!\n", cname, spec);
+         }
+      }
+      else
+      {
+         System.err.printf("ERROR: Malformed object spec %s!\n", spec);
+      }
+      
+      return cls;
+   }
    
    /**
     * Check if the callee's type can be written back to a wider caller's type, when viewed from the
@@ -3867,30 +4415,47 @@
     * </pre>
     * <p>
     * Object types narrow by these rules:
-    *
+    * <ol>
+    *    <li> We check if the callee matches a child class of the caller type's specific class.  The
+    *         nearest child class is matched with highest priority.
+    * </ol>
     *
     * @param    caller
     *           The caller's passed instance's data type.
     * @param    callee
     *           The candidate callee method's parameter data type.
+    * @param    incrementer
+    *           Code to be executed to increment the inheritance level.
     *
     * @return   {@code true} if a narrowing operation is possible.
     */
-   private boolean isNarrowingTypeMatch(String caller, String callee)
+   private boolean isNarrowingTypeMatch(String caller, String callee, Runnable incrementer)
    {
-      if (("int64".startsWith(caller)      && "integer".startsWith(callee))               ||
-          ("longchar".startsWith(caller)   && "character".startsWith(callee))             ||
-          ("datetime".startsWith(caller)   && "date".startsWith(callee))                  ||
-          ("datetimetz".startsWith(caller) && ("date".startsWith(callee) || "datetime".startsWith(callee))))
+      if (("int64".equals(caller)      && "integer".equals(callee))                             ||
+          ("decimal".equals(caller)    && ("integer".equals(callee) || "int64".equals(callee))) ||
+          ("longchar".equals(caller)   && "character".equals(callee))                           ||
+          ("datetime".equals(caller)   && "date".equals(callee))                                ||
+          ("datetimetz".equals(caller) && ("date".equals(callee) || "datetime".equals(callee))))
       {
          return true;
       }
           
       if (caller.startsWith("object") && callee.startsWith("object"))
       {
-         return true;
+         // parse out the classes
+         ClassDefinition src = parseObjectSpec(caller);
+         ClassDefinition tgt = parseObjectSpec(callee);
+         
+         // check if the target parameter is a child class of the caller (this explicitly ignores
+         // implemented interfaces which is how the 4GL does it)
+         if (tgt.isInheritedFrom(src, false, incrementer))
+         {
+            return true;
+         }
+         
+         return false;
       }
-      
+                
       return false;
    }
    
@@ -3908,32 +4473,57 @@
     * datetime           datetime-tz
     * </pre>
     * <p>
-    * Object types narrow by these rules:
-    *
+    * Object types widen by these rules:
+    * <ol>
+    *    <li> We check if the callee matches any of the interfaces implemented by the caller type's specific class.
+    *    <li> We check if the callee matches any of the parent class hierarchy (and their implemented interfaces)
+    *         of the caller type's specific class.
+    *    <li> We check if the callee is Progress.Lang.Object.  This check has lowest priority.
+    * </ol>
     *
     * @param    caller
     *           The caller's passed instance's data type.
     * @param    callee
     *           The candidate callee method's parameter data type.
+    * @param    incrementer
+    *           Code to be executed to increment the inheritance level.
     *
     * @return   {@code true} if a widening operation is possible.
     */
-   private boolean isWideningTypeMatch(String caller, String callee)
+   private boolean isWideningTypeMatch(String caller, String callee, Runnable incrementer)
    {
-      if (("int64".startsWith(caller) && "decimal".startsWith(callee))                                   ||
-          ("integer".startsWith(caller) && ("int64".startsWith(callee) || "decimal".startsWith(callee))) ||
-          ("character".startsWith(caller) && "longchar".startsWith(callee))                              ||
-          ("datetime".startsWith(caller) && "datetimetz".startsWith(callee))                             ||
-          ("date".startsWith(caller) && ("datetime".startsWith(callee) || "datetimetz".startsWith(callee))))
+      if (("int64".equals(caller) && "decimal".equals(callee))                                   ||
+          ("integer".equals(caller) && ("int64".equals(callee) || "decimal".equals(callee)))     ||
+          ("character".equals(caller) && "longchar".equals(callee))                              ||
+          ("datetime".equals(caller) && "datetimetz".equals(callee))                             ||
+          ("date".equals(caller) && ("datetime".equals(callee) || "datetimetz".equals(callee))))
       {
          return true;
       }
+      
+      if (caller.startsWith("object") && callee.startsWith("object"))
+      {
+         // parse out the classes
+         ClassDefinition src = parseObjectSpec(caller);
+         ClassDefinition tgt = parseObjectSpec(callee);
+         
+         // check if the target is in the interface list of the caller type's specific class
+         if (src.isImplemented(tgt))
+         {
+            return true;
+         }
+         
+         // check if the target matches the caller type's parent class hierarchy (including implemented
+         // interfaces)
+         if (src.isInheritedFrom(tgt, true, incrementer))
+         {
+            return true;
+         }
+
+         // lowest priority/last ditch check
+         return "progress.lang.object".equals(tgt.getName());
+      }
                 
-      if (caller.startsWith("object") && callee.startsWith("object"))
-      {
-         return true;
-      }
-      
       return false;
    }
    
@@ -4155,15 +4745,15 @@
    }
    
    /**
-    * Helper method to register a virtual enum method.
+    * Helper method to register a public virtual method.
     *
     * @param    name
-    *           Fully qualified class name of this enum.
+    *           Fully qualified class name.
     * @param    ori
     *           Legacy method name.
     * @param    meth
     *           Converted method name.
-    * @param    statc
+    * @param    isStatic
     *           {@code true} if this is a static method, {@code false} for instance methods.
     * @param    rtype
     *           Method's return token type.
@@ -4175,325 +4765,186 @@
    private void registerVirtual(String         name,
                                 String         ori,
                                 String         meth,
-                                boolean        statc,
+                                boolean        isStatic,
                                 int            rtype,
                                 String         qname,
                                 ParameterKey[] parms)
    {
-      String key = ori.toLowerCase();
-      
-      if (imethods == null)
-      {
-         imethods = new HashMap<>();
-         smethods = new HashMap<>();
-      }
-      
-      Map<String, Map<SignatureKey, MemberData>> methods = statc ? smethods : imethods;
-      Map<SignatureKey, MemberData>              defs    = methods.get(key);
-      
-      if (defs == null)
-      {
-         defs = new HashMap<>();
-         methods.put(key, defs);
-      }
-      
-      MemberData mdat = createMethod(ori, parms, KW_PUBLIC, true, rtype, qname, meth, -1, nextTempIdx());
-      defs.put(new SignatureKey(parms), mdat);
-      
-      String legacySignature = SymbolResolver.calculateLegacySignature(mdat.name, mdat.signature);
-      javaMethodNames.put(legacySignature, meth);
-   }
-   
-   /**
-    * Create a new method definition and track it.
-    *  
-    * @param    name
-    *           The legacy method name.
-    * @param    sig
-    *           The method signature.
-    * @param    accessMode
-    *           The access mode.
-    * @param    isStatic
-    *           Flag indicating if the method is static or not.
-    * @param    retType
-    *           The return type.
-    * @param    qualified
-    *           The qualified legacy class name, for methods returning object.
-    * @param    javaname
-    *           The converted java name.
-    * @param    extent
-    *           The extent (for the return type).
-    * @param    tempIdx
-    *           The tempIdx to use.
-    *           
-    * @return   The created method.
-    */
-   private MemberData createMethod(String name,
-                                   ParameterKey[] sig, 
-                                   int accessMode, 
-                                   boolean isStatic,
-                                   int retType,
-                                   String qualified,
-                                   String javaname,
-                                   int extent,
-                                   int tempIdx)
-   {
-      MemberData mdat = new MemberData(name, 
-                                       null, 
-                                       sig, 
-                                       retType, 
-                                       accessMode,
-                                       isStatic, 
-                                       qualified, 
-                                       this, 
-                                       tempIdx,  
-                                       null); // TODO: this is not used by MemberData
-      mdat.javaname = javaname;
-      mdat.extent = extent;
-      SymbolResolver.trackMethodSignature(mdat.javaname, name, sig);
-      
-      return mdat;
-   }
-   
-   /**
-    * Stores a member's data.
-    */
-   private static class MemberData
-   {
-      /** Text name. */
-      private String name = null;
-      
-      /** Token type. */
-      private int type = -1;
-      
-      /** Extent value (defaults to 0, which means scalar) of the return type. */
-      private int extent = 0;
-      
-      /** Access mode. */
-      private int access = -1;
-      
-      /** Temporary ID. */
-      private int tempIdx = -1;
-      
-      /** Static or instance member. */
-      private boolean isStatic = false;
-      
-      /** Class type name for members that return an object instance. */
-      private String qname = null;
-      
-      /** Parameter signature for methods. */
-      private ParameterKey[] signature = null;
-      
-      /** Associated variable instance for data members. */
-      private Variable var = null; // used only during parsing/front phase
-      
-      /** The containing class where this was defined. */
-      private ClassDefinition container = null;
-      
-      /** The parameter modes. */
-      private String modes = null;
-      
-      /**
-       * Marker for OO vars which are gathered during pre-scan, and they might not be actual class
-       * members (as pre-scan processes DEFINE VAR statements at all levels, including methods).
-       */
-      private boolean provisional = false;
-      
-      /** The AST for this member definition. After parsing is finished, this is cleared. */
-      private Aast ast = null;
-      
-      /** The AST's ID for this member definition. */
-      private Long astId = null;
+      createMethod(null, ori, parms, KW_PUBLIC, true, rtype, qname, meth, -1, nextTempIdx(), false, false);
+   }
+   
+   /**
+    * Create a new method definition and track it.
+    *  
+    * @param    name
+    *           The legacy method name.
+    * @param    sig
+    *           The method signature.
+    * @param    accessMode
+    *           The access mode.
+    * @param    isStatic
+    *           Flag indicating if the method is static or not.
+    * @param    retType
+    *           The return type.
+    * @param    qualified
+    *           The qualified legacy class name, for methods returning object.
+    * @param    javaname
+    *           The converted java name.
+    * @param    extent
+    *           The extent (for the return type).
+    * @param    tempIdx
+    *           The tempIdx to use.
+    * @param    override
+    *           {@code true} if the method is an override of a parent class/interface method.
+    * @param    abstr
+    *           {@code true} if the method is abstract of a parent class/interface method.
+    *           
+    * @return   The created method.
+    */
+   private MemberData createMethod(Map<SignatureKey, MemberData> defs,
+                                   String                        name,
+                                   ParameterKey[]                sig, 
+                                   int                           accessMode, 
+                                   boolean                       isStatic,
+                                   int                           retType,
+                                   String                        qualified,
+                                   String                        javaname,
+                                   int                           extent,
+                                   int                           tempIdx,
+                                   boolean                       override,
+                                   boolean                       abstr)
+   {
+      return createMethod(defs, name, sig, accessMode, isStatic, retType, qualified,
+                          javaname, extent, tempIdx, override, abstr, null, false);
+   }
+   
+   /**
+    * Create a new method definition and track it.
+    *  
+    * @param    name
+    *           The legacy method name.
+    * @param    sig
+    *           The method signature.
+    * @param    accessMode
+    *           The access mode.
+    * @param    isStatic
+    *           Flag indicating if the method is static or not.
+    * @param    retType
+    *           The return type.
+    * @param    qualified
+    *           The qualified legacy class name, for methods returning object.
+    * @param    javaname
+    *           The converted java name.
+    * @param    extent
+    *           The extent (for the return type).
+    * @param    tempIdx
+    *           The tempIdx to use.
+    * @param    override
+    *           {@code true} if the method is an override of a parent class/interface method.
+    * @param    abstr
+    *           {@code true} if the method is abstract of a parent class/interface method.
+    * @param    register
+    *           {@code true} if the name should be registered in the maps.
+    *           
+    * @return   The created method.
+    */
+   private MemberData createMethod(Map<SignatureKey, MemberData> defs,
+                                   String                        name,
+                                   ParameterKey[]                sig, 
+                                   int                           accessMode, 
+                                   boolean                       isStatic,
+                                   int                           retType,
+                                   String                        qualified,
+                                   String                        javaname,
+                                   int                           extent,
+                                   int                           tempIdx,
+                                   boolean                       override,
+                                   boolean                       abstr,
+                                   Map<String, Object>           ret,
+                                   boolean                       register)
+   {
+      synchronized (lock)
+      {
+         if (defs == null)
+         {
+            defs = getMethodStore(name, isStatic);
+         }
+         
+         MemberData mdat = new MemberData(name, 
+                                          null, 
+                                          sig, 
+                                          retType, 
+                                          accessMode,
+                                          isStatic, 
+                                          qualified, 
+                                          this, 
+                                          tempIdx,  
+                                          ret);
+         mdat.extent   = extent;
+         mdat.override = override;
+         mdat.abstr = abstr;
+         
+         defs.put(new SignatureKey(sig), mdat);
+         
+         if (register)
+         {
+            registerMethod(javaname, mdat);
+         }
+         
+         return mdat;
+      }
+   }
+   
+   /**
+    * Returns the result from a method lookup.
+    */
+   private static class MethodSearchResult
+   {
+      /** The method that was found. */
+      final private MemberData data;
+      
+      /** Type overrides for fuzzy matches. */
+      final private String[] overrides;
 
-      /** All annotations set at the method's return type. */
-      // WARNING: this is not set by initialize, in case of METHOD
-      private Map<String, Object> retType;
-      
-      /** 
-       * The converted Java name for this member. Used only for previously parsed classes, or
-       * legacy builtin classes.
-       */
-      private String javaname = null;
-      
-      /**
-       * Create an instance, setting the data members.
-       *
-       * @param    name
-       *           The name of the member.
-       * @param    var
-       *           Associated variable instance for data members or <code>null</code>.
-       * @param    signature
-       *           Parameter signature for methods or <code>null</code>.
-       * @param    type
-       *           The token type associated with the member.
-       * @param    access
-       *           Access mode (<code>KW_PUBLIC</code>,
-       *           <code>KW_PROTECTD</code> or <code>KW_PRIVATE</code>).
-       * @param    isStatic
-       *           <code>true</code> if the variable/property is static.
-       * @param    qname
-       *           Fully qualified class name where <code>type</code> equals
-       *           <code>OO_METH_CLASS</code>. <code>null</code> if this method
-       *           does not return an object instance.
-       * @param    container
-       *           The container class definition.
-       * @param    tempIdx
-       *           Temporary ID.
-       */
-      public MemberData(String          name,
-                        Variable        var,
-                        ParameterKey[]  signature,
-                        int             type,
-                        int             access,
-                        boolean         isStatic,
-                        String          qname,
-                        ClassDefinition container,
-                        int             tempIdx,
-                        Map<String, Object> retType)
-      {
-         this.name      = name;
-         this.var       = var;
-         this.signature = signature;
-         this.type      = type;
-         this.access    = access;
-         this.isStatic  = isStatic;
-         this.qname     = qname;
-         this.retType   = retType;
-         this.container = container;
-         this.tempIdx   = tempIdx;
-         
-         if (signature != null)
-         {
-            this.modes = "";
-            for (ParameterKey pk : signature)
-            {
-               if (pk.mode == null)
-               {
-                  modes = modes + "B";
-                  continue;
-               }
-               
-               switch (pk.mode)
-               {
-                  case KW_INPUT:
-                     modes = modes + "I";
-                     break;
-                  case KW_OUTPUT:
-                     modes = modes + "O";
-                     break;
-                  case KW_IN_OUT:
-                     modes = modes + "U";
-                     break;
-                  case KW_BUFFER:
-                     modes = modes + "B";
-                     break;
-               }
-            }
-         }
-      }
-      
-      /**
-       * The parse for this entire file has finished, and the AST IDs have been computed.  
-       * This is the time the capture the AST IDs or add other annotations, as is executed just
-       * before the AST is persisted.
-       */
-      public void parseFinished()
-      {
-         BiConsumer<Aast, Aast> p = (ast, parent) ->
-         {
-            if (ast.isAnnotation("access-mode"))
-            {
-               parent.putAnnotation("access-mode", (Long) ast.getAnnotation("access-mode"));
-               ast.removeAnnotation("access-mode");
-            }
-            if (ast.isAnnotation("oo-data-store"))
-            {
-               parent.putAnnotation("oo-data-store", (String) ast.getAnnotation("oo-data-store"));
-               ast.removeAnnotation("oo-data-store");
-            }
-            if (ast.isAnnotation("static"))
-            {
-               parent.putAnnotation("static", (Boolean) ast.getAnnotation("static"));
-               ast.removeAnnotation("static");
-            }
-         };
-         if (ast != null)
-         {
-            int type = ast.getType();
-            if (type == KW_TEMP_TAB ||
-                (type == SYMBOL && ast.getParent().getType() == DEFINE_BUFFER))
-            {
-               Aast parent = ast.getParent();
-               p.accept(ast, parent);
-               
-               if (type == KW_TEMP_TAB || type == KW_WORK_TAB)
-               {
-                  ast = parent;
-               }
-               else
-               {
-                  ast = parent;
-                  ast = ast.getImmediateChild(KW_FOR, null);
-                  ast = (Aast) ast.getFirstChild();
-               }
-            }
-            if (type == SYMBOL && ast.upPath("DEFINE_QUERY/KW_QUERY"))
-            {
-               Aast parent = ast.getAncestor(2);
-               p.accept(ast, parent);
-               
-               parent.putAnnotation("name", ast.getText());
-               ast = parent;
-            }
-            
-            astId = ast.getId();
-            ast = null;
-         }
-      }
-      
-      /**
-       * Set the {@link #provisional} state of this member.
-       * 
-       * @param    provisional
-       *           The new state.
-       */
-      public void setProvisional(boolean provisional)
-      {
-         this.provisional = provisional;
-      }
-      
-      /**
-       * Render the state of the instance in a text form.
-       *
-       * @return   The rendered instance.
-       */
-      public String toString()
-      {
-         StringBuilder sb = new StringBuilder();
-         
-         String qual = (qname == null) ? "" : String.format(" - %s", qname);
-         
-         sb.append(String.format("%s %b member %s (%s%s), extent %d in class %s, tempIdx %d\n",
-                                 ProgressParser.lookupTokenName(access),
-                                 isStatic,
-                                 name,
-                                 ProgressParser.lookupTokenName(type),
-                                 qual,
-                                 extent,
-                                 container.getName(),
-                                 tempIdx));
-          
-         if (signature != null)
-         {
-            sb.append(String.format("   PARAMETERS: %d\n", signature.length));
-            
-            for (int i = 0; i < signature.length; i++)
-            {
-               sb.append(String.format("      %s\n", signature[i]));
-            }
-         }
-         
-         return sb.toString();
+      /**
+       * Create an dynamic invocation instance.
+       */
+      MethodSearchResult()
+      {
+         data      = null;
+         overrides = null;
+      }
+      
+      /**
+       * Create an instance using the given result.
+       * 
+       * @param    data
+       *           The result of the search.
+       */
+      MethodSearchResult(MemberData data, String[] overrides)
+      {
+         this.data      = data;
+         this.overrides = overrides;
+      }
+      
+      /**
+       * Reports if this is a dynamic invocation.
+       * 
+       * @return   {@code true} if this is a dynamic invocation.
+       */
+      boolean isDynamic()
+      {
+         return data == null;
+      }
+      
+      /**
+       * Obtain any types overrides which are needed because of fuzzy matching.
+       *  
+       * @return   The type overrides defined for this match or {@code null} if there are no overrides.
+       */
+      String[] getOverrides()
+      {
+         return overrides;
       }
    }
 }

